//+------------------------------------------------------------------+
//|                                         LuKu_SIDSOK_ENTRY_v4.mq4 |
//|                                                             LuKu |
//|                                               http://luku.cz/fx/ |
//+------------------------------------------------------------------+
#property copyright "LuKu"
#property link      "http://luku.cz/fx/"
#property show_inputs
/*
   SKRIPT pro zadavani obchodu v SID SOKu

   DOKUMENTACE http://luku.cz/fx/2011/08/10/sidsok-entry-v4/
   
   Zadame vyvazene pary tvorici rovnou PL krivku a system nastavi cekajici limity v pozadovanych vzdalenostech
   V prubehu zacne dochazet k aktivaci cekacek, staci pak sledovat PL krivku a pary naraz soucasne uzavirat
   
   Verze 1 (30.7.2011)
     - zakladni naprogramovani podle popisu donnyho (http://www.fxstreet.cz/diskusni-forum+statisticka-arbitrage.html?active_page=90&)
   Verze 2 (1.8.2011)
     - moznost volby zadavani cekacek v trendu / protitrendu (zahedgovani dvou sad) - parametr TrendTradeType
   Verze 3 (1.8.2011)
     - uprava smeru cekacek, nove je moznost je nastavit v jednom smeru
     - zmena defaultniho nastaveni (smer cekacek podle SID SOK)
     - oprava chyb v nazvech promennych
     - dodan test na jedinecny magick number (testuje zda jiz neni pouzito v konkretnim obchodu)
     - dodan test na zavedeni obchodu kdy v pripade chyby se daji obchody automaticky zrusit (vyskoci dialog)
   Verze 4 (10.8.2011)
     - skript nov umouje otevrat nejen ekajc pkazy ale i market (okamit) pokyny, parametr OpenOnlyBuySellTrades
     - dodna podpora individuln velikosti lotu pro ppad OpenOnlyBuySellTrades = True, pry pak zadvejte ve formtu EURUSD:0.11,GBPUSD:0.2,AUDUSD,...
     - pidna automatick podpora pro mini symboly (IBFX ty)
     - pidn parametr MaxSlippage = 5; na maximln prokluz pkaz
     - nov monost zvolit konkrtni nebo generovan MagickNumber
     - zrychleno zavdn (vyputno vypisovn hlek o oteven do konzole)
     - dodno vypisovn prbhu skriptu na obrazovku (vypisuje se jako comment pod jmno pru vlevo nahoe)
*/

extern string    Buy         = "Symboly ke koupi oddelene carkou";
//extern string    Buys_Long   = "EURUSD";
//extern string    Buys_Long   = "USDJPY,EURUSD,EURCHF,GBPJPY,USDCAD,CADJPY"; // LUKU
//extern string    Buys_Long   = "USDJPY,EURUSD,EURCHF,GBPJPY,USDCAD,CADJPY,AUDUSD"; // LUKU vyvazene
//extern string    Buys_Long   = "GBPUSD,USDJPY,EURJPY"; // SID?
//extern string    Buys_Long   = "EURGBP,EURCAD,EURJPY,GBPJPY,AUDJPY,GBPCHF"; // SID PINFX?
//extern string    Buys_Long   = "USDJPY,EURUSD,EURCHF,GBPJPY,USDCAD,CADJPY,AUDUSD"; // puvodni T101 OREST zavisla na brokorovi
//extern string    Buys_Long   = "EURUSD,AUDUSD,CADJPY,USDJPY,USDCAD,GBPJPY,EURCHF"; // UNI T101
extern string    Buys_Long   = "GBPUSD,EURJPY"; //donny pary

extern string    Sell        = "Symboly k prodeji oddelene carkou";
//extern string    Sells_Short = "EURGBP,GBPUSD";
//extern string    Sells_Short = "EURJPY,GBPUSD,EURGBP,GBPCHF,CHFJPY,USDCHF"; // LUKU pomer je 6,88:6,61 ve prospech sell, tedy buy je o 0,04lotu slabsi
//extern string    Sells_Short = "EURUSD,USDCHF,CHFJPY,GBPJPY"; // SID? pomer 4,49:3,53 ve prospech sell, tedy nutno upravit na pomer 0,1:0,127 lotu
//extern string    Sells_Short = "EURUSD,GBPUSD,AUDUSD,USDJPY,USDCHF,USDCAD"; // SID PINFX?
//extern string    Sells_Short = "EURJPY,GBPUSD,EURGBP,GBPCHF,CHFJPY,USDCHF,AUDJPY"; // puvodni T101 OREST zavisla na brokorovi
//extern string    Sells_Short = "GBPCHF,USDCHF,GBPUSD,AUDJPY,EURJPY,CHFJPY,EURGBP"; // UNI T101
extern string    Sells_Short = "EURUSD,GBPJPY"; // donny pary

extern string SLotSizes = "Velikosti lotu oddelenych carkou";
extern string LotSizes = "0.03,0.06,0.1,0.13,0.16,0.2,0.23,0.26";

extern string SLotRanges = "Velikosti pipu vzdalenosti oddelenych carkou";
extern string LotRanges = "10,20,40,80,160,320,640,1280";
extern string sOthers = "----------------------------------------------------------------------";
/*
  Obchodovani ve vyznacenem trendu - buy pary budou buy a sell budou sell. Zde to lze otocit
  Oproti aktualni cene:
    True  - cekacka dole u BUY paru aktivuje prodej, cekacka nahore nakup
    False - cekacka dole u BUY paru aktivuje nakup, cekacka nahore prodej
*/
extern string sTrendTradeType = "True - cekacky v trendu, False - proti trendu";
extern bool TrendTradeType = true;

/*
  Zpusob zavedeni cekacek, standardne jsou ve smeru trendu (nad i pod cenou buy pro buy pary).
  Timto to lze otocit (zahedgovat), tedy pro buy pary bude nahore buy a dole pod cenou pak sell ci obracene (dle TrendTradeType)
  Oproti aktualni cene:
    True  - hedgujeme a cekacky jsou proti sobe (buy i sell oproti aktualni cene)
    False - vypnuto - cekacky jsou vzdy v jednom smeru nad i pod cenou buy nebo sell (dle nastaveni TrendTradeType)
*/
extern string sHedgePendingPosition = "True - cekajici prikazy jsou proti sobe (hedge), False - jsou v jednom smeru";
extern bool HedgePendingPosition = false; // false - priklad: u vsechn BUY paru budou nad i pod aktualni cenou BUY (pokud je nastaveno TrendTradeType = true)
extern string sHedgePendingPositionType = "1-> BUYSTOP/SELLSTOP pro BUY a SELL pary, 2-> BUYSTOP/SELLSTOP pro BUY a BUYLIMIT/SELLLIMIT pro SELL";
extern int HedgePendingPositionType = 1;
extern string sOthers2 = "----------------------------------------------------------------------";

extern string sOpenOnlyBuySellTrades = "True - otevre pouze Buy a Sell prikazy, False - vytvari cekacky";
extern bool OpenOnlyBuySellTrades = false;
extern double OpenOnlyBuySellLots = 0.1; // default velikost lotu
extern string sOthers3 = "----------------------------------------------------------------------";

extern int MaxSlippage = 5; // maximalni hodnota prokluzu
extern string sUseConcreteMagickNumber = "True - pouzije konkretni MagickNumber, False - vygeneruje unikatni";
extern bool UseConcreteMagickNumber = false;
extern int ConcreteMagickNumber = 0;

// win veci
#include <stderror.mqh>
#include <stdlib.mqh>
#include <WinUser32.mqh>

// interni promenne
string aBuyPairs[];  // pole naparsovanych paru nakup
string aSellPairs[]; // pole naparsovanych paru prodej
double aBuyPairsLot[];
double aSellPairsLot[];
string aLotSizes[];  // pole lotu
string aLotRanges[]; // pole rozsahu pro cekacky
string Res;
int MagickNumber; // interne vygenerovane unikatni magick number
int Err;
string m; // parametr mini uctu napriklad IBFX

//+------------------------------------------------------------------+
//| START                                                            |
//+------------------------------------------------------------------+
int start(){
   // je vse pripraveno a ok?
   Comment("LuKu SIDSOK ENTRY START");
   if(scriptInit() == false){
     Alert("Vsechny parametry nejsou OK, zastavuji beh!");
     Comment("");
     return(0);
   }
    
   // trendove / protitrendove cekacky?
   int bUpType, bDownType, sUpType, sDownType;
   if(TrendTradeType == true){
     // jedeme v trendu
     if(HedgePendingPosition == true){
       if(HedgePendingPositionType == 1){
         // cekacky od sebe, typ 1 vse ve stejnem smeru
         bUpType = OP_BUYSTOP;
         bDownType = OP_SELLSTOP;
         sUpType = bUpType;
         sDownType = bDownType;
       }else{
         // cekacky od sebe, typ 2 pro sell jiny smer
         bUpType = OP_BUYSTOP;
         bDownType = OP_SELLSTOP;
         sUpType = OP_SELLLIMIT;
         sDownType = OP_BUYLIMIT;
       }
     }else{
       bUpType = OP_BUYSTOP;
       bDownType = OP_BUYLIMIT;
       sUpType = OP_SELLLIMIT;
       sDownType = OP_SELLSTOP;
     }
   }else{
     // jedeme proti trendu
     if(HedgePendingPosition == true){
       if(HedgePendingPositionType == 1){
         // cekacky proti sobe, typ 1 vse ve stejnem smeru
         bUpType = OP_SELLLIMIT;
         bDownType = OP_BUYLIMIT;
         sUpType = bUpType;
         sDownType = bDownType;
       }else{
         // cekacky od sebe, typ 2 pro sell jiny smer
         bUpType = OP_SELLLIMIT;
         bDownType = OP_BUYLIMIT;
         sUpType = OP_BUYSTOP;
         sDownType = OP_SELLSTOP;
       }
     }else{
       bUpType = OP_SELLLIMIT;
       bDownType = OP_SELLSTOP;
       sUpType = OP_BUYSTOP;
       sDownType = OP_BUYLIMIT;
     }
   }

   // zavedeni obchodu
   if(createTrades(bUpType, bDownType, sUpType, sDownType) == true){
     Alert("VSE OK!");
   }else{
     // neco se nam nepodarilo
     // zobrazime hlasku na zruseni obchodu
     if(MessageBox("ERROR pri zrizovani obchodu: "+GetLastError()+"\nZRUSIT PRIKAZY?", "Otazka", MB_YESNO|MB_ICONQUESTION) == IDYES){
       // rusime zavedene pokyny dle magick number
       if(subCloseTrade(MagickNumber) == true){
         Alert("Obchody korektne zruseny, VSE OK.");
       }else{
         Alert("POZOR! obchody nebyly zruseny!");
       }
     }else{
       Alert("POZOR! obchody nebyly zruseny!");
     }
   }
   Comment("");
   return(0);
}
//+------------------------------------------------------------------+

// pocatecni inicializace a nacteni promennych
bool scriptInit(){
   // uprava uzivatelskeho vstupu
   Buys_Long = StringUpperCase(StringTrimLeft(StringTrimRight(Buys_Long)));
   Sells_Short = StringUpperCase(StringTrimLeft(StringTrimRight(Sells_Short)));
   
   // zjisteni typu uctu - parametr ktery se pridava k parum
   m = StringSubstr(Symbol(),6,StringLen(Symbol())-6);
   
   // parsovani symbolu
   pairsToArray(aBuyPairs, aBuyPairsLot, Buys_Long);
   pairsToArray(aSellPairs, aSellPairsLot, Sells_Short);
   
   // existuji zadane pary?
   Res = testPairsIfExists(aBuyPairs);
   if(Res != ""){
     Alert(StringConcatenate("Neexistujici Buy par! - '",Res,"'"));
     return(false);
   }
   // existuji zadane pary?
   Res = testPairsIfExists(aSellPairs);
   if(Res != ""){
     Alert(StringConcatenate("Neexistujici Sell par! - '",Res,"'"));
     return(false);
   }
   
   // parsovani lotu
   stringToArray(aLotSizes, LotSizes);
   // parsovani rozsahu
   stringToArray(aLotRanges, LotRanges);
   
   // overime pocet lotu VS pocet Rozsahu
   if(ArraySize(aLotSizes) != ArraySize(aLotRanges)){
     Alert(StringConcatenate("Neexistujici Buy par! - '",Res,"'"));
     return(false);
   }
   
   // mame povoleni obchodovat?
   if(IsTradeAllowed() == false){
     Alert("Neni povoleno obchdovani!");
     return(false);
   }
   
   // vygenerujeme unikatni MagickNumber
   if(UseConcreteMagickNumber == true){
     MagickNumber = ConcreteMagickNumber;
   }else{
     MagickNumber = makeMagicNumber(StringConcatenate(TimeToStr(TimeCurrent(), TIME_SECONDS), Buys_Long, Sells_Short));
   }
   // test zda neni jiz toto cislo aktualni pouzito, pokud ano, vygenerovat nove, jinak obchod nepovolit
   if(isExistTradeByMagickNumber(MagickNumber) == true){
     Alert("Vygenerovane MagickNumber jiz existuje! zadejte prikaz znovu (pripadne zmente MagickNumber), vygeneruji nove.");
     return(false);
   }
   
   return(true);
}

// provede zavedeni obchodu, pokud se cokoliv nepovede vraci false
bool createTrades(int ibUpType, int ibDownType, int isUpType, int isDownType){
   // pro smycky
   int i,j;
   int pos = 0; // vypisovaci pozice
   int maxpos = 0;
   
   if(OpenOnlyBuySellTrades == true){
     // okamzite obchody
     maxpos = ArraySize(aBuyPairs) + ArraySize(aSellPairs);
     // BUY
     for(i=0; i<ArraySize(aBuyPairs); i++){
       pos++;
       Comment("CREATE BUY "+pos+"/"+maxpos+" "+aBuyPairs[i]);
       if(createOrder(aBuyPairs[i], aBuyPairsLot[i], OP_BUY, MagickNumber, MagickNumber) == false) return(false);
     }
     // SELL
     for(i=0; i<ArraySize(aSellPairs); i++){
       pos++;
       Comment("CREATE BUY "+pos+"/"+maxpos+" "+aSellPairs[i]);
       if(createOrder(aSellPairs[i], aSellPairsLot[i], OP_SELL, MagickNumber, MagickNumber) == false) return(false);
     }
   }else{
     // cekajici obchody
     maxpos = ArraySize(aBuyPairs)*(ArraySize(aLotRanges)*2) + ArraySize(aSellPairs)*(ArraySize(aLotRanges)*2);
     // BUY
     for(i=0; i<ArraySize(aBuyPairs); i++){
       // nastavime jednotilive cekacky pro dany par
       for(j=0; j<ArraySize(aLotRanges); j++){
         pos++;
         Comment("CREATE BUY "+pos+"/"+maxpos+" "+aBuyPairs[i]+"/"+aLotSizes[j]+" - "+aLotRanges[j]);
         if(createWaitOrder(aBuyPairs[i], StrToDouble(aLotSizes[j]), ibUpType, StrToDouble(aLotRanges[j]), MagickNumber, MagickNumber) == false) return(false);
         pos++;
         Comment("CREATE BUY "+pos+"/"+maxpos+" "+aBuyPairs[i]+"/"+aLotSizes[j]+" - "+aLotRanges[j]);
         if(createWaitOrder(aBuyPairs[i], StrToDouble(aLotSizes[j]), ibDownType, StrToDouble(aLotRanges[j]), MagickNumber, MagickNumber) == false) return(false);
       }
     }
     // SELL
     for(i=0; i<ArraySize(aSellPairs); i++){
       Comment("CREATE SELL "+(i+1)+"/"+ArraySize(aSellPairs));
       // nastavime jednotilive cekacky pro dany par
       for(j=0; j<ArraySize(aLotRanges); j++){
         pos++;
         Comment("CREATE SELL "+pos+"/"+maxpos+" "+aSellPairs[i]+"/"+aLotSizes[j]+" - "+aLotRanges[j]);
         if(createWaitOrder(aSellPairs[i], StrToDouble(aLotSizes[j]), isUpType, StrToDouble(aLotRanges[j]), MagickNumber, MagickNumber) == false) return(false);
         pos++;
         Comment("CREATE SELL "+pos+"/"+maxpos+" "+aSellPairs[i]+"/"+aLotSizes[j]+" - "+aLotRanges[j]);
         if(createWaitOrder(aSellPairs[i], StrToDouble(aLotSizes[j]), isDownType, StrToDouble(aLotRanges[j]), MagickNumber, MagickNumber) == false) return(false);
       }
     }
   }
   return(true);
}

// zavede cekajici pokyn
bool createWaitOrder(string symbol, double lot, int type, double range, string comment, int MN = 0){
  // zjistime aktualni cenu
  double actualPrice = 0.0;
  
  // provedeme pricteni range k aktualni cene
  switch(type){
   case OP_SELLLIMIT:
     actualPrice = MarketInfo(symbol, MODE_BID);
     actualPrice += convertPoint(symbol, range);
     break;
   case OP_BUYLIMIT:
     actualPrice = MarketInfo(symbol, MODE_ASK);
     actualPrice -= convertPoint(symbol, range);
     break;
   case OP_SELLSTOP:
     actualPrice = MarketInfo(symbol, MODE_BID);
     actualPrice -= convertPoint(symbol, range);
     break;
   case OP_BUYSTOP:
     actualPrice = MarketInfo(symbol, MODE_ASK);
     actualPrice += convertPoint(symbol, range);
     break;
   default:
     Alert("Nepovoleny typu obchodu!");
     return(false);
     break;
  }
  
  // zadani prikazu
  int ticket = OrderSend(symbol, type, lot, actualPrice, MaxSlippage, 0, 0, comment, MN);
  if(ticket > 0){  
    // vypiseme obchod na konzoli - nevypisujeme je to zbytecne pomale
    // if(OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) OrderPrint(); 
  }else{
    Err = GetLastError();
    Alert(StringConcatenate("Error OrderSend? Symbol:", symbol, ", aPrice:", DoubleToStr(actualPrice, 5), ", Point:", DoubleToStr(convertPoint(symbol, range),5), ", Range: ", DoubleToStr(range,0), " - ", Err, " / ", ErrorDescription(Err)));
    return(false);
  }
  return(true);
}

// zavede okamzity pokyn
bool createOrder(string symbol, double lot, int type, string comment, int MN = 0){
  // zjistime aktualni cenu
  double actualPrice = 0.0;
  
  // provedeme pricteni range k aktualni cene
  switch(type){
   case OP_SELL:
     actualPrice = MarketInfo(symbol, MODE_BID);
     break;
   case OP_BUY:
     actualPrice = MarketInfo(symbol, MODE_ASK);
     break;
   default:
     Alert("Nepovoleny typu obchodu!");
     return(false);
     break;
  }
  
  // zadani prikazu
  int ticket = OrderSend(symbol, type, lot, actualPrice, MaxSlippage, 0, 0, comment, MN);
  if(ticket > 0){  
    // vypiseme obchod na konzoli
    if(OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) OrderPrint(); 
  }else{
    Err = GetLastError();
    Alert(StringConcatenate("Error OrderSend? Symbol:", symbol, ", Lot: ", DoubleToStr(lot, 5), ", aPrice:", DoubleToStr(actualPrice, 5), " - ", Err, " / ", ErrorDescription(Err)));
    return(false);
  }
  return(true);
}

//prevede body na cenu
double convertPoint(string symbol, double price){
 RefreshRates();
 double point = MarketInfo(symbol, MODE_POINT);  
 if(point == 0.00001)
   return(price * (point*10.0));
 if(point == 0.0001)
   return(price * (point));
 if(point == 0.001)
   return(price * (point*10.0));
 if(point == 0.01)
   return(price * (point));
}

// otestuje zda vsechny pary v poli existuji + upravuje pary pro mini ucty, poud je to potreba
// "" vse ok, "PAR" jinak vraci par ktery neexistuje
string testPairsIfExists(string &aPairs[]){
  for(int i=0; i<ArraySize(aPairs); i++){
    if(iClose(aPairs[i],0,0) == 0){
      // zkusime s m
      if(iClose(StringConcatenate(aPairs[i],m),0,0) == 0){
        return(aPairs[i]+m); // neexistuje
      }else{
        // existuje, zaznamename
        aPairs[i] = StringConcatenate(aPairs[i],m);
      }
    }
  }
  return("");
}

// prevod na velka pismena
string StringUpperCase(string str){
   string   s = str;
   int      lenght = StringLen(str) - 1;
   int      char;
   while(lenght >= 0){
     char = StringGetChar(s, lenght);
     if((char > 96 && char < 123) || (char > 223 && char < 256)){
       s = StringSetChar(s, lenght, char - 32);
     }else {
       if(char > -33 && char < 0){
         s = StringSetChar(s, lenght, char + 224);
       }
     }
     lenght--;
   }
   return(s);
}

// preparsovani hodnot oddelenych oddelovacem do pole
// aResult - pole cilovych retezcu
// values - z ceho parsujeme
// delimiter - co nase texty oddeluje
void stringToArray(string &aResult[], string &values, string delimiter = ","){
   // vymazani pole
   ArrayResize(aResult,0);
   int s = 0;
   int i = 0;
   string current;
   // dodani posledni carky kvuli podpore i jednoho 
   if (StringSubstr(values,StringLen(values),1) != delimiter){
     values = StringConcatenate(values, delimiter);
   }
   // prvni vyskyt
   i = StringFind(values, delimiter, s);
   // dokud tam neco je tak parsujeme
   while (i > 0){
     current = StringSubstr(values, s, i-s); // vyparsovani prvni hodnoty
     ArrayResize(aResult,ArraySize(aResult)+1); // pridame dalsi pozici
     aResult[ArraySize(aResult)-1] = current; // pridame dalsi hodnotu
     s = i + 1;
     i = StringFind(values, delimiter, s); // dalsi vyskyt
   }
}

// preparsovani paru oddelenych carkou do pole
void pairsToArray(string &aResult[], double &aPairsLot[], string &pairs){
   int s = 0;
   int i = 0;
   int x = 0;
   double xLot = 0;
   string current;
   // dodani posledni carky kvuli podpore i jednoho 
   if (StringSubstr(pairs,StringLen(pairs),1) != ","){
     pairs = StringConcatenate(pairs,",");
   }
   // prvni carka
   i = StringFind(pairs, ",", s);
   // dokud tam neco je tak parsujeme
   while (i > 0){
     current = StringSubstr(pairs, s, i-s); // vyparsovani prvniho paru
     // a nemame v paru i velikost lotu?
     x = StringFind(current, ":", 0);
     xLot = OpenOnlyBuySellLots;
     if(x > 0){ // ano nasli jsme :
       // vykopitovani velikosti lotu
       xLot = StrToDouble(StringSubstr(current, x+1, StringLen(current)));
       // vykopirovani symbolu
       current = StringSubstr(current, 0, x);
     }
     // pridame par
     ArrayResize(aResult,ArraySize(aResult)+1); // pridame dalsi pozici
     aResult[ArraySize(aResult)-1] = current; // pridame vybrany symbol
     // pridani lotu
     ArrayResize(aPairsLot,ArraySize(aPairsLot)+1);
     aPairsLot[ArraySize(aPairsLot)-1] = xLot;
     s = i + 1;
     i = StringFind(pairs, ",", s); // dalsi carka
   }
}

/**
* create a positive integer for the use as a magic number.
*
* The function takes a string as argument and calculates
* an 31 bit hash value from it. The hash does certainly not 
* have the strength of a real cryptographic hash function 
* but it should be more than sufficient for generating a
* unique ID from a string and collissions should not occur.
*
* use it in your init() function like this: 
*    magic = makeMagicNumber(WindowExpertName() + Symbol() + Period());
*
* where name would be the name of your EA. Your EA will then
* get a unique magic number for each instrument and timeframe
* and this number will always be the same, whenever you put
* the same EA onto the same chart.
*
* Numbers generated during testing mode will differ from those
* numbers generated on a live chart.
*/
int makeMagicNumber(string key){
   int i, k;
   int h = 0;
   if (IsTesting()){
      key = "_" + key;
   }
   for (i=0; i<StringLen(key); i++){
      k = StringGetChar(key, i);
      h = h + k;
      h = bitRotate(h, 5); // rotate 5 bits
   }
   for (i=0; i<StringLen(key); i++){
      k = StringGetChar(key, i);
      h = h + k;
      // rotate depending on character value
      h = bitRotate(h, k & 0x0000000F);
   }
   // now we go backwards in our string
   for (i=StringLen(key); i>0; i--){   
      k = StringGetChar(key, i - 1);
      h = h + k;
      // rotate depending on the last 4 bits of h
      h = bitRotate(h, h & 0x0000000F); 
   }
   return(h & 0x7fffffff);
}

/**
* Rotate a 32 bit integer value bit-wise 
* the specified number of bits to the right.
* This function is needed for calculations
* in the hash function makeMacicNumber()
*/
int bitRotate(int value, int count){
   int i, tmp, mask;
   mask = (0x00000001 << count) - 1;
   tmp = value & mask;
   value = value >> count;
   value = value | (tmp << (32 - count));
   return(value);
}

// test na existenci obchodu s konkretnim magickNumber
int isExistTradeByMagickNumber(int magick){
  // projedeme vsechny obchody a zkusime najit stejne cislo
  for(int i=OrdersTotal()-1;i>=0;i--){
    if(OrderSelect(i, SELECT_BY_POS) == false){
      // objednavku nelze vybrat
      Sleep(1000);
      RefreshRates();
      return(-1);
    }
    if(magick == OrderMagicNumber() || magick == StrToInteger(OrderComment())){
      // nalezeno
      return(1);
    }
  }
  return(0);
}

// funkce volana z closeTrade, kvuli reuse
// type = 1 - profit; -1 - loss; 0 - all (+ magickNum)
// symbol - uzavreni pouze konkretniho symbolu (+ magickNum)
bool subCloseTrade(int magickNum, int type = 0){
  int err;
  string errTxt;
   // uzavirani
  for(int i=OrdersTotal()-1;i>=0;i--){
    if(OrderSelect(i, SELECT_BY_POS) == false){
      // objednavku nelze vybrat
      RefreshRates(); Sleep(2000);
      return(false);
    }
    // mame stejne magicknumber? pokud ne tak preskakujeme
    if(OrderMagicNumber() != magickNum && StrToInteger(OrderComment()) !=  magickNum) continue;
    if(type == 1){
      // uzavirame pouze ziskove obchody
      if(OrderProfit() <= 0) continue;
    }else{
      if(type == -1){
        // uzavirame pouze ztratove
        if(OrderProfit() >= 0) continue;
      }
    }
    // uzavirani
    bool result = false;
    switch(OrderType()){
      //Close opened long positions
      case OP_BUY       : result = OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), MaxSlippage, Red);
                          break;
      //Close opened short positions
      case OP_SELL      : result = OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), MaxSlippage, Red);
                          break;
      //Close pending orders
      case OP_BUYLIMIT  :
      case OP_BUYSTOP   :
      case OP_SELLLIMIT :
      case OP_SELLSTOP  : result = OrderDelete(OrderTicket());
    }
    // povolime obchody ostatnim
    if(result == false){
      RefreshRates(); Sleep(2000);
      return(false);
    }
  }
  return(true);
}